Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.io
Class StringReader

    java.lang.Object
      |
      +--java.io.Reader
            |
            +--java.io.StringReader

public class StringReader
extends Reader

A character stream whose source is a string.

Since:
  JDK1.1

Fields inherited from class java.io.Reader
`lock`

Constructor Summary
`StringReader(String s)` Create a new string reader.

Method Summary
`void` | `close()` Close the stream.
`void` | `mark(int readAheadLimit)` Mark the present position in the stream.
`boolean` | `markSupported()` Tell whether this stream supports the mark() operation, which it does.
`int` | `read()` Read a single character.
`int` | `read(char[] cbuf, int off, int len)` Read characters into a portion of an array.
`boolean` | `ready()` Tell whether this stream is ready to be read.
`void` | `reset()` Reset the stream to the most recent mark, or to the beginning of the string if it has never been marked.
`long` | `skip(long ns)` Skip characters.

Methods inherited from class java.io.Reader
`read`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### StringReader

    public StringReader(String s)

  Create a new string reader.
  Parameters:
    `s` - String providing the character stream.

Method Detail

### read

    public int read()
             throws IOException

  Read a single character.
  Overrides:
    `read` in class `Reader`
  Returns:
    The character read, or -1 if the end of the stream has been reached
  Throws:
    `IOException` - If an I/O error occurs

### read

    public int read(char[] cbuf,
                    int off,
                    int len)
             throws IOException

  Read characters into a portion of an array.
  Overrides:
    `read` in class `Reader`
  Parameters:
    `cbuf` - Destination buffer
    `off` - Offset at which to start writing characters
    `len` - Maximum number of characters to read
  Returns:
    The number of characters read, or -1 if the end of the stream has been reached
  Throws:
    `IOException` - If an I/O error occurs

### skip

    public long skip(long ns)
              throws IOException

  Skip characters.
  Overrides:
    `skip` in class `Reader`
  Throws:
    `IOException` - If an I/O error occurs

### ready

    public boolean ready()
                  throws IOException

  Tell whether this stream is ready to be read.
  Overrides:
    `ready` in class `Reader`
  Returns:
    True if the next read() is guaranteed not to block for input
  Throws:
    `IOException` - If the stream is closed

### markSupported

    public boolean markSupported()

  Tell whether this stream supports the mark() operation, which it does.
  Overrides:
    `markSupported` in class `Reader`
  Following copied from class: `java.io.Reader`
  Returns:
    true if and only if this stream supports the mark operation.

### mark

    public void mark(int readAheadLimit)
              throws IOException

  Mark the present position in the stream. Subsequent calls to reset() will reposition the stream to this point.
  Overrides:
    `mark` in class `Reader`
  Parameters:
    `readAheadLimit` - Limit on the number of characters that may be read while still preserving the mark. Because the stream's input comes from a string, there is no actual limit, so this argument must not be negative, but is otherwise ignored.
  Throws:
    `IllegalArgumentException` - If readAheadLimit is < 0
    `IOException` - If an I/O error occurs

### reset

    public void reset()
               throws IOException

  Reset the stream to the most recent mark, or to the beginning of the string if it has never been marked.
  Overrides:
    `reset` in class `Reader`
  Throws:
    `IOException` - If an I/O error occurs

### close

    public void close()

  Close the stream.
  Overrides:
    `close` in class `Reader`
  Following copied from class: `java.io.Reader`
  Throws:
    `IOException` - If an I/O error occurs

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.